<template>
	<xn-form-container
		:title="formData.id ? '编辑单位组' : '增加单位组'"
		:width="700"
		:visible="visible"
		:destroy-on-close="true"
		@close="onClose"
	>
		<a-form ref="formRef" :model="formData" :rules="formRules" layout="vertical">
			<a-form-item label="编码：">
				<a-input v-model:value="formData.number" placeholder="不输入自动生成" allow-clear />
			</a-form-item>
			<a-form-item label="名称：" name="name" props="name">
				<a-input v-model:value="formData.name" placeholder="请输入名称" allow-clear />
			</a-form-item>
			<a-form-item label="状态：" name="enabledState" props="enabledState">
				<a-select
					v-model:value="formData.enabledState"
					placeholder="请选择状态"
					:options="tool.dictList('COMMON_STATUS')"
				/>
			</a-form-item>
		</a-form>
		<OperationalInformation :detailData="formData" :colSpan="12" v-if="formData.id"></OperationalInformation>
		<template #footer>
			<a-button style="margin-right: 8px" @click="onClose">关闭</a-button>
			<a-button type="primary" @click="onSubmit" :loading="submitLoading">保存</a-button>
		</template>
	</xn-form-container>
</template>

<script setup name="sysUnitGroupForm">
	import tool from '@/utils/tool'
	import { cloneDeep } from 'lodash-es'
	import { required } from '@/utils/formRules'
	import sysUnitGroupApi from '@/api/base/unit/unitGroupsApi'
	// 抽屉状态
	const visible = ref(false)
	const emit = defineEmits({ successful: null })
	const formRef = ref()
	// 表单数据
	const formData = ref({
		number: '',
		name: '',
		enabledState: 'ENABLE'
	})
	const submitLoading = ref(false)
	const enabledStateOptions = ref([])

	// 打开抽屉
	const onOpen = (record) => {
		visible.value = true
		if (record) {
			let recordData = cloneDeep(record)
			formData.value = Object.assign({}, recordData)
		} else {
			formData.value.number = ''
			formData.value.name = ''
			formData.value.enabledState = 'ENABLE'
			formData.id = ''
		}
	}
	// 关闭抽屉
	const onClose = () => {
		formRef.value.resetFields()
		visible.value = false
	}
	// 默认要校验的
	const formRules = {
		name: [required('请输入名称')],
		enabledState: [required('请输入状态')]
	}
	// 验证并提交数据
	const onSubmit = () => {
		formRef.value.validate().then(() => {
			submitLoading.value = true
			const formDataParam = cloneDeep(formData.value)
			sysUnitGroupApi
				.sysUnitGroupSubmitForm(formDataParam, formDataParam.id)
				.then(() => {
					onClose()
					emit('successful')
				})
				.finally(() => {
					submitLoading.value = false
				})
		})
	}
	// 抛出函数
	defineExpose({
		onOpen
	})
</script>
